<template>
  <div :class="classes">
    <textarea
      class="form-control"
      v-if="type == 'textarea'"
      rows="20"
      v-model="text"
    ></textarea>
    <div class="modal-body">
      <div class="row">
        <div class="col-sm-8 ng-star-inserted">
          <center><b>Desktop</b></center>

          <div class="esdev-desktop-device">
            <!-- <div class="esdev-email-window-panel">
              <span class="es-icon-user-account esdev-email-user-avatar"></span>
              <div class="esdev-email-subject" style="min-height: 20px">
                &nbsp;
              </div>
            </div> -->
            <iframe
              v-if="strings()"
              :src="baseURL"
              class="esdev-desktop-device-screen"
            ></iframe>
          </div>
        </div>

        <center><b>Mobile</b></center>

        <div class="col-sm-4 esdev-no-padding-left ng-star-inserted">
          <div class="esdev-mobile-device center-block">
            <div class="esdev-mobile-device-screen">
              <img alt="" src="@/assets/img/mobile-view-top-bar.png" />
              <iframe
                v-if="strings()"
                :src="baseURL"
                class="esdev-desktop-device-screen"
              ></iframe>
              <img
                alt=""
                class="esdev-mail-bottom-bar"
                src="@/assets/img/mobile-view-bottom-bar.png"
              />
            </div>
          </div>
        </div>
      </div>
    </div>

    <div class="popup_footer">
      <button type="button" class="btn btn-primary" v-on:click="copy">
        Copy as HTML code
      </button>

      <base-button
        @click="$emit('on-close')"
        class="btn btn-default"
        role="button"
        >Close</base-button
      >
    </div>
  </div>
</template>

<script>
import { ModalBus } from "../eventBus";
import { htmlView } from "../utils/viewHtml/responsiveEmail/index";
import { mapGetters } from "vuex";

export default {
  data() {
    return {
      baseURL: window.location.href + "iframe",
      locations: window.location.href
    };
  },
  props: {
    type: {
      type: String,
      value: "error" | "info" | "success" | "warning" | "texterea" | "html"
    },
    text: String,
    template: String
  },
  computed: {
    ...mapGetters(["GETTER_DATA_BANNER", "GETTER_DATA_TOP_PICK"]),
    color() {
      switch (this.type) {
        case "error":
          return "red";
        case "success":
          return "teal";
        case "warning":
          return "orange";
        case "info":
        default:
          return "gray";
      }
    },
    classes() {
      const { color } = this;
      return [
        `bg-${color}-400 border border-${color}-200 text-black px-4 py-3 rounded-lg relative`
      ];
    }
  },
  methods: {
    strings() {
      let data = {
        banner: this.GETTER_DATA_BANNER,
        topPick: this.GETTER_DATA_TOP_PICK
      };

      return JSON.stringify(data);
    },
    copy() {
      var input = document.createElement("textarea");

      input.innerHTML = this.template;
      document.body.appendChild(input);
      input.select();
      document.execCommand("copy");
      document.body.removeChild(input);

      ModalBus.$emit("showNotify", {
        type: "info",
        text: "Copied HTML code Successfully!"
      });
    }
  }
};
</script>

<style scoped>
iframe.esdev-desktop-device-screen {
  width: 100%;
  height: 1000px;
  border: none;
}
.popup_content {
  font-size: 15px;
  padding-bottom: 1em;
}
.popup_footer {
  padding: 1em 0;
  text-align: center;
}
.popup_footer button {
  display: inline-block;
  margin: 0 0.5em;
}
.modal-dialog {
  background: #fff;
  padding: 20px;
  box-shadow: 0 4px 8px 0 rgba(255, 255, 255, 0.2),
    0 6px 20px 0 rgba(255, 255, 255, 0.19);
  /* transition: 0.5s; */
  position: relative;
  max-height: 98%;
}

@import url("../assets/css/response.css");
</style>

<style>
.modal-dialog {
  width: 90% !important;
}
</style>
